#include <stdio.h>
#include <stdlib.h>
#include "base.h"

// Calculates n!

int main(int argc, char** argv)
{
	InitBase();

	if (argc < 2)
	{
		cout << "Usage: " << argv[0] << " number" << endl;	
		return 1;
	}

	long n = atoi(argv[1]);
	if (n < 0)
	{
		cout << argv[0] << ": Negative argument not permitted" << endl;	
		return 1;
	}

	verylong f = 0;
	fac((ulong) n, &f);
	cout << f << endl;
	zfree(&f);
	return 0;

}

