#include <stdio.h>
#include <stdlib.h>
#include "base.h"


int main(int argc, char** argv)
{
	verylong n = 0;
	verylong b = 0;

	if (argc < 3)
	{
		cout << "Usage: " << argv[0] << " number base" << endl;
		return 1;
	}

	if (zsread(argv[1], &n) == 0)
	{
		cout << "Usage: " << argv[0] << " number base" << endl;
		return 1;
	}

	if (zsread(argv[2], &b) == 0)
	{
		cout << "Usage: " << argv[0] << " number base" << endl;
		return 1;
	}

	InitBase();
	verylong m = 0;
	verylong t = 0;
	z2div(n, &m);
	zexpmod(b, m, n, &t);
	cout << t << endl;
	return 0;

}

