#include <stdio.h>
#include <stdlib.h>
#include "base.h"

// Search for pseudoprimes

int main(int argc, char** argv)
{
	verylong	n = 0;
	verylong	b = 0;

	if (argc < 3)
	{
		printf("Usage: %s start base\n", argv[0]);
		return 1;
	}

	if (zsread(argv[1], &n) == 0 || zsign(n) <= 0)
	{
		printf("Usage: %s start base\n", argv[0]);
		return 1;
	}

	if (zsread(argv[2], &b) == 0 || zscompare(b, 2) < 0)
	{
		printf("Usage: %s start base\n", argv[0]);
		return 1;
	}

	trace_level = 1;

	InitBase();
	InitCheckMark(argv[0]);
	Carmichael(n, b);

	return 0;

}

