#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "base.h"


const int	incr_period = 2310;
extern short	incr_list[];
extern int	incr_len;


int main()
{
	IntList f1;
	IntList f2;
	IntList f3;

	srand((int) time(NULL));
	InitBase();
	verylong C = 0, D = 0;

	zuintoz(100000, &C);
	z2div(C, &D);
	trace_level = 1;

	do
	{
		verylong l = 0;
		verylong r = 0;
		verylong n = 0;

		zrandomb(C, &l);
		zrandomb(D, &r);
		// n = C * l + 2 * r + 1;
		zsread("111314749076240640447182515169", &n);

		if (zscompare(n, 2) < 0)
			continue;

		cout << "n = " << n << endl;
		factor_brute3(n, 0, ztouint(C), f1, f2, f3);
		cout << "n - 1 = " << f1 << endl;
		cout << "n     = " << f2 << endl;
		cout << "n + 1 = " << f3 << endl;
		zsadd(n, -1, &n);
		f1.Multiply(&r);
		if (zcompare(r, n) != 0)
		{
			cout << "factor_brute3 is incorrect" << endl;
			return 1;
		}
		zsadd(n, 1, &n);
		f2.Multiply(&r);
		if (zcompare(r, n) != 0)
		{
			cout << "factor_brute3 is incorrect" << endl;
			return 1;
		}
		zsadd(n, 1, &n);
		f3.Multiply(&r);
		if (zcompare(r, n) != 0)
		{
			cout << "factor_brute3 is incorrect" << endl;
			return 1;
		}
		zfree(&l);
		zfree(&r);
		zfree(&n);
	} while (1);

	return 0;
}

